// (c) Copyright 2011-2012 Cloudera, Inc. All rights reserved.

define(["knockout","cloudera/EventSearch"],function(e,t){var n=t.FilterModel,r=t.FilterViewModel;describe("FilterModel",function(){var e,t;beforeEach(function(){e={filters:jasmine.createSpy()},t=new n(e)}),it("defines some attributes",function(){expect(t.filter).toBeDefined(),expect(t.compareType).toBeDefined(),expect(t.value).toBeDefined(),expect(t.values).toBeDefined(),expect(t.filterName).toBeDefined(),expect(t.compareTypeName).toBeDefined()}),it("is complete when all values are satisfied for single value case",function(){t.filter("filter"),expect(t.complete()).toBeFalsy(),t.compareType("=="),expect(t.complete()).toBeFalsy(),t.value("value"),expect(t.complete()).toBeTruthy()}),it("is complete when all values are satisfied for multi-value case",function(){t.filter("filter"),expect(t.complete()).toBeFalsy(),t.compareType("=="),expect(t.complete()).toBeFalsy(),t.values(["value1","value2"]),expect(t.complete()).toBeTruthy()}),it("will only be activated if not already active and called by button",function(){var e=$('<div class="btn"></div>').appendTo($("body")),n=$("<div></div>").appendTo($("body")),r={target:n[0]},i=!1;t.active.subscribe(function(){i=!0}),expect(t.active()).toBeFalsy(),t.activate(t,r),expect(t.active()).toBeTruthy(),expect(i).toBeTruthy(),t.active(!1),i=!1,r.target=e[0],t.activate(t,r),expect(t.active()).toBeFalsy(),expect(i).toBeFalsy(),r.target=n[0],t.active(!0),i=!1,t.activate(t,r),expect(t.active()).toBeTruthy(),expect(i).toBeFalsy(),e.remove(),n.remove()}),it("knows how to compare against others of its type in single value case",function(){var e=new n;e.filter("filter"),e.compareType("=="),e.value("value"),t.filter("filter"),t.compareType("=="),t.value("value"),expect(t.compareTo(e)).toBeTruthy(),e.filter("bad"),expect(t.compareTo(e)).toBeFalsy(),e.filter(t.filter()),e.compareType("bad"),expect(t.compareTo(e)).toBeFalsy(),e.compareType(t.compareType()),e.value("bad"),expect(t.compareTo(e)).toBeFalsy(),e.value(t.value()),expect(t.compareTo(e)).toBeTruthy()}),it("knows how to compare against others of its type in multi-value case with different order",function(){var e=new n;e.filter("filter"),e.compareType("=="),e.values(["value1","value2"]),t.filter("filter"),t.compareType("=="),t.values(["value2","value1"]),expect(t.compareTo(e)).toBeTruthy()}),it("can compare to falsy correctly",function(){expect(t.compareTo(null)).toBeFalsy(),expect(t.compareTo(undefined)).toBeFalsy()}),it("will not notify observers of change to values property if array does not change",function(){var e=jasmine.createSpy();t.values.subscribe(e),t.values([]),expect(e).wasNotCalled(),t.values([1]),expect(e).wasCalled(),e.reset(),t.values([2]),expect(e).wasCalled(),e.reset(),t.values([]),expect(e).wasCalled()}),it("sets filter properly by name",function(){var n={propertyName:"catpants"},r={propertyName:"doggiehat"};e.filters.andReturn([n,r]),t.filterName("doggiehat"),expect(t.filter()).toEqual(r),t.filterName("horsepoo"),expect(t.filter()).toEqual(null)}),it("tracks filter name as a property",function(){t.filter({propertyName:"catpants"}),expect(t.filterName()).toEqual("catpants"),t.filter({propertyName:"doggiehat"}),expect(t.filterName()).toEqual("doggiehat")}),it("is careful about setting compareType by name when filter is null",function(){t.filter(null),t.compareTypeName("catpants"),expect(t.compareTypeName()).toBeFalsy()}),it("sets compareType by name",function(){var e={name:"catpants"},n={name:"doggiehat"};t.filter({compareTypes:[e,n]}),t.compareTypeName("doggiehat"),expect(t.compareType()).toEqual(n),t.compareTypeName("horsepoo"),expect(t.compareType()).toEqual(null)}),it("provides values as comma-delimited string",function(){expect(t.value()).toEqual(""),t.values(["catpants","doggiehat"]),expect(t.value()).toEqual("catpants,doggiehat")}),it("allows values to be set as comma-delimited string",function(){expect(t.values().length).toEqual(0),t.value("catpants,doggiehat"),expect(t.values().length).toEqual(2);var e=t.values();expect(e[0]).toEqual("catpants"),expect(e[1]).toEqual("doggiehat")})}),describe("FilterViewModel",function(){var t,n;beforeEach(function(){t={activeFilter:e.observable(),appliedFilters:e.observableArray(),appendFilter:jasmine.createSpy("appendFilter"),loading:jasmine.createSpy("loading"),filters:jasmine.createSpy("filters"),removeFilter:jasmine.createSpy("removeFilter"),findFilter:jasmine.createSpy("findFilter"),compareTypeFromName:function(){}},n=new r(t)}),it("defines some attributes",function(){expect(n.activeFilter).toBeDefined(),expect(n.appliedFilters).toBeDefined(),expect(n.loading).toBeDefined(),expect(n.filters).toBeDefined(),expect(n.removeFilter).toBeDefined(),expect(n.findFilter).toBeDefined()}),it("appends filters",function(){spyOn(t,"compareTypeFromName").andReturn("compareType"),expect(n.appliedFilters().length).toEqual(0),t.appendFilter.andReturn(!0);var e=n.appendFilter("filter","compareTypeName","value");expect(e).toBeTruthy(),expect(t.appendFilter).wasCalled()}),it("converts single value to singleton array for values",function(){spyOn(t,"compareTypeFromName").andReturn("compareType"),n.appendFilter("filter","compareTypeName","catpants"),expect(t.appendFilter).wasCalled();var e=t.appendFilter.mostRecentCall.args[0];expect(e.values().length).toEqual(1),expect(e.values()[0]).toEqual("catpants")}),it("will convert appended filter compare type if given string",function(){spyOn(t,"compareTypeFromName").andReturn("compareType"),t.appendFilter.andReturn(!0);var e=n.appendFilter("filter","compareTypeName","value");expect(e).toBeTruthy(),expect(t.compareTypeFromName).wasCalled(),t.compareTypeFromName.reset(),e=n.appendFilter("filter",{},"value"),expect(e).toBeTruthy(),expect(t.compareTypeFromName).wasNotCalled()}),it("will fail if compare type is not found",function(){spyOn(t,"compareTypeFromName").andReturn(null);var e=n.appendFilter("filter","compareTypeName","value");expect(e).toBeFalsy(),expect(t.compareTypeFromName).wasCalled()}),it("can deactivate filters",function(){spyOn(n,"activeFilter").andReturn(null),n.deactivateFilters(),expect(n.activeFilter).wasCalled(),n.activeFilter.reset();var e={active:jasmine.createSpy("active")};n.activeFilter.andReturn(e),n.deactivateFilters(),expect(n.activeFilter).wasCalled(),expect(e.active).wasCalledWith(!1)}),it("can add another filter while one is active",function(){spyOn(n,"deactivateFilters"),spyOn(n,"appendFilter"),n.addAnother(),expect(n.deactivateFilters).wasCalled(),expect(n.appendFilter).wasCalled()})}),describe("EventSearch",function(){var r,i,s,o,u,a,f;beforeEach(function(){jasmine.Ajax.useMock(),f={status:200,responseText:JSON.stringify({success:!0})},r=$("<div></div>").appendTo($("body")),i=$("<div></div>").appendTo($("body")),s=[],o=jasmine.createSpy(),u=jasmine.createSpy(),a=new t(r[0],i[0],"test/filters/url",[],o,u)}),afterEach(function(){r.remove(),i.remove()}),it("defines some attributes",function(){expect(a.error).toBeDefined(),expect(a.filterContainer).toBeDefined(),expect(a.filters).toBeDefined(),expect(a.staticFilters).toBeDefined(),expect(a.appliedFilters).toBeDefined(),expect(a.filterPath).toBeDefined(),expect(a.activeFilter).toBeDefined(),expect(a.eventList).toBeDefined(),expect(a.events).toBeDefined(),expect(a.loading).toBeDefined(),expect(a.dataSource).toBeDefined(),expect(a.exportEvents).toBeDefined(),expect(a.viewModel).toBeDefined()}),it("applies bindings upon instantiation",function(){spyOn(e,"applyBindings"),a=new t(r[0],i[0],"test/filters/url",[],o,u),expect(e.applyBindings.callCount).toEqual(2);var n=e.applyBindings.argsForCall[0];expect(n[0]).toEqual(a.viewModel),expect(n[1]).toEqual(r[0]),n=e.applyBindings.argsForCall[1],expect(n[1]).toEqual(i[0])}),it("exposes a subset of itself as a view model to the event list",function(){spyOn(e,"applyBindings"),a=new t(r[0],i[0],"test/filters/url",[],o,u),expect(e.applyBindings.callCount).toEqual(2);var n=e.applyBindings.argsForCall[1],s=n[0];expect(s.loading).toEqual(a.loading),expect(s.error).toEqual(a.error),expect(s.events).toEqual(a.events)}),it("exposes a hasFilterNamed function to the event list",function(){spyOn(e,"applyBindings"),a=new t(r[0],i[0],"test/filters/url",[],o,u),expect(e.applyBindings.callCount).toEqual(2);var n=e.applyBindings.argsForCall[1],s=n[0];a.filters([{propertyName:"catpants"},{propertyName:"doggiehat"}]),expect(s.hasFilterNamed("catpants")).toBeTruthy(),expect(s.hasFilterNamed("horsepoo")).toBeFalsy()}),it("can get a compare type from its name",function(){var e={name:"compareType1"},t={name:"compareType2"},n={compareTypes:[e,t]},r=a.compareTypeFromName(n,"compareType2");expect(r).toEqual(t),r=a.compareTypeFromName(n,"unknown"),expect(r).toBeFalsy()}),it("getHead and getTail work when there are no events",function(){expect(a.length()).toEqual(0),expect(a.getHead()).toBeNull(),expect(a.getTail()).toBeNull()}),it("getHead and getTail work when there are events",function(){a.events([1,2,3]),expect(a.length()).toEqual(3),expect(a.getHead()).toEqual(1),expect(a.getTail()).toEqual(3)}),it("can splice events to the end",function(){a.events([1,2,3]),expect(a.length()).toEqual(3),a.splice(0),expect(a.length()).toEqual(0),a.events([1,2,3]),a.splice(3,0,4),expect(a.length()).toEqual(4);var e=a.events();expect(e[0]).toEqual(1),expect(e[1]).toEqual(2),expect(e[2]).toEqual(3),expect(e[3]).toEqual(4)}),it("correctly appends filters",function(){var e=new n;expect(a.appliedFilters().length).toEqual(0),a.appendFilter(e),expect(a.appliedFilters().length).toEqual(1)}),it("does not append if any filters are duplicates",function(){var e=new n;e.filter("filter"),e.compareType("compareType"),e.value("value"),expect(a.appliedFilters().length).toEqual(0),a.appendFilter(e),expect(a.appliedFilters().length).toEqual(1);var t=new n;t.filter("filter"),t.compareType("compareType"),t.value("value"),a.appendFilter(t),expect(a.appliedFilters().length).toEqual(1)}),it("sets filter to active if not complete",function(){var e=new n;expect(e.complete()).toBeFalsy(),expect(e.active()).toBeFalsy(),a.appendFilter(e),expect(e.active()).toBeTruthy()}),it("tracks which filter is the active one and allows only one",function(){var e=new n;e.filter("filter1"),e.compareType("compareType1"),e.value("value1");var t=new n;t.filter("filter2"),t.compareType("compareType2"),t.value("value2"),a.appendFilter(e),a.appendFilter(t),expect(a.appliedFilters().length).toEqual(2),e.active(!0),expect(e.active()).toBeTruthy(),expect(t.active()).toBeFalsy(),t.active(!0),expect(e.active()).toBeFalsy(),expect(t.active()).toBeTruthy()}),it("removes incomplete active filters when deactivated",function(){var e=new n;e.filter("filter1"),a.appendFilter(e),expect(e.active()).toBeTruthy(),expect(a.activeFilter()).toEqual(e),expect(a.appliedFilters().length).toEqual(1),a.deactivateAllFilters(),expect(a.appliedFilters().length).toEqual(0),expect(a.activeFilter()).toBeFalsy()}),it("tracks filters and removes uncompleted deactivated ones",function(){spyOn(a,"removeFilter");var e=new n;a.appendFilter(e),expect(e.active()).toBeTruthy(),expect(e.complete()).toBeFalsy(),expect(a.appliedFilters().length).toEqual(1),e.active(!1),expect(a.removeFilter).wasCalled()}),it("fires an event when an active, completed filter is set inactive",function(){spyOn($,"publish");var e=new n;a.appendFilter(e),expect($.publish).wasNotCalled(),expect(e.active()).toBeTruthy(),expect(e.complete()).toBeFalsy(),expect(a.appliedFilters().length).toEqual(1),e.filter("filter1"),e.compareType("compareType1"),e.value("value1"),expect(e.complete()).toBeTruthy(),e.active(!1),expect($.publish).wasCalledWith("eventsearch.appliedfilters.changed")}),it("knows how to remove a filter",function(){var e=new n;e.filter("filter1"),e.compareType("compareType1"),e.value("value1");var t=new n;t.filter("filter2"),t.compareType("compareType2"),t.value("value2"),a.appendFilter(e),a.appendFilter(t),expect(a.appliedFilters().length).toEqual(2);var r=0;a.appliedFilters.subscribe(function(){r+=1}),a.removeFilter(e),expect(a.appliedFilters().length).toEqual(1),expect(r).toEqual(1),expect(e.active()).toBeFalsy(),expect(a.activeFilter()).toEqual(null)}),it("deactivates an active filter when it is removed",function(){var e=new n;e.filter("filter1"),e.compareType("compareType1"),e.value("value1"),a.appendFilter(e),e.active(!0),expect(a.activeFilter()).toEqual(e),a.removeFilter(e),expect(a.activeFilter()).toEqual(null)}),it("correctly deactivates filters",function(){var e=new n;a.appendFilter(e),expect(e.active()).toBeTruthy(),a.deactivateAllFilters(),expect(e.active()).toBeFalsy()}),it("correctly prepends events",function(){var e=new n;e.name="event1";var t=a.prepend(e);expect(t).toEqual(1);var r=new n;r.name="event2";var i=new n;i.name="event3",t=a.prepend([r,i]),expect(t).toEqual(3);var s=a.events();expect(s[0].name).toEqual("event2"),expect(s[1].name).toEqual("event3"),expect(s[2].name).toEqual("event1"),a.events([]),expect(a.length()).toEqual(0),t=a.prepend([e,r,i]),expect(t).toEqual(a.length())}),it("correctly appends events",function(){var e=new n;e.name="event1";var t=a.append(e);expect(t).toEqual(1);var r=new n;r.name="event2";var i=new n;i.name="event3",t=a.append([r,i]),expect(t).toEqual(3);var s=a.events();expect(s[0].name).toEqual("event1"),expect(s[1].name).toEqual("event2"),expect(s[2].name).toEqual("event3"),a.events([]),expect(a.length()).toEqual(0),t=a.append([e,r,i]),expect(t).toEqual(a.length())}),it("loads filters via a getJSON call",function(){spyOn(a,"loadFiltersHandler"),a.loadFilters();var e=mostRecentAjaxRequest();e.response(f),expect(a.loadFiltersHandler).wasCalled()}),it("knows how to handle the filters response from the server",function(){a.filters([1,2]);var e={message:"OK",data:[4,5,6]};a.loadFiltersHandler(e),expect(a.filters().length).toEqual(3);var t=a.filters();expect(t[0]).toEqual(4),expect(t[1]).toEqual(5),expect(t[2]).toEqual(6)}),it("calls a callback when filters are loaded",function(){a.filters([1,2]);var e=jasmine.createSpy("load filters callback");a.loadFilters(e);var t=mostRecentAjaxRequest();t.response(f),expect(e).wasCalled()}),it("has method for retrying the dataSource after a time",function(){var e=!0,t=jasmine.createSpy(),n=5;runs(function(){a.retryHandlerAfterTime(e,t,n)}),waitsFor(function(){return o.callCount>0},"dataSource never called",n*2),runs(function(){var n=o.mostRecentCall.args;expect(n[0]).toEqual(a),expect(n[1]).toEqual(e),expect(n[2]).toEqual(t)})}),it("knows how to handle errors when loading data",function(){var e=a.makeLoadDataHandler(!0);expect(a.error()).toBeFalsy(),a.loading(!0),e(null),expect(a.error()).toBeFalsy(),expect(a.loading()).toBeFalsy(),a.loading(!0);var t="catpants";e(t),expect(a.error()).toEqual(t),expect(a.loading()).toBeFalsy()}),it("knows how to call callbacks when loading data",function(){var e=jasmine.createSpy().andReturn(!1);spyOn(a,"retryHandlerAfterTime");var t=a.makeLoadDataHandler(!0,e);t(null),expect(e).wasCalled(),expect(a.retryHandlerAfterTime).wasNotCalled(),e.andReturn(!0),t("error"),expect(e).wasCalledWith("error"),expect(a.retryHandlerAfterTime).wasCalled()}),it("knows how to load data",function(){var e="handler",t=function(){};spyOn(a,"makeLoadDataHandler").andReturn(e),a.error("catpants error"),expect(a.loading()).toBeFalsy(),a.loadData(!0,t),expect(a.error()).toBeFalsy(),expect(a.loading()).toBeTruthy(),expect(o).wasCalledWith(a,!0,e),a.error("catpants error"),a.loading(!1),o.reset(),a.loadData(t),expect(a.error()).toBeFalsy(),expect(a.loading()).toBeTruthy(),expect(o).wasCalledWith(a,undefined,e)}),it("can return all the applied filters",function(){var e=function(e){var t=new n;return t.filter({propertyName:"propertyName "+e}),t.compareType({name:"compareType "+e}),t.value("value "+e),t},t=e(1),r=e(2),i=e(3),s=new n;s.filter({propertyName:"propertyName 4"}),s.compareType({name:"compareType 4"}),s.values(["value 4.1","value 4.2"]),i.value(null);var o={values:["value 0"]};a.staticFilters=[o],a.appliedFilters([t,r,i,s]);var u=a.getAppliedFilters();expect(u.length).toEqual(4),expect(u[0].values).toEqual(["value 0"]),expect(u[1].values).toEqual(["value 1"]),expect(u[2].values).toEqual(["value 2"]);var f=u[3].values;expect(f.length).toEqual(2),expect(f[0]).toEqual("value 4.1"),expect(f[1]).toEqual("value 4.2")}),it("can apply filters to the view model",function(){spyOn(a.viewModel,"appendFilter"),a.applyFilter("filter","compareType","value"),expect(a.viewModel.appendFilter).wasCalledWith("filter","compareType","value")}),it("can clear events",function(){a.events([1,2,3]),a.clear(),expect(a.events().length).toEqual(0)}),it("can find filters",function(){var e={propertyName:"filter1"},t={propertyName:"filter2"},n={propertyName:"filter3"};a.filters([e,t,n]);var r=a.findFilter("filter2");expect(r).toEqual(t),r=a.findFilter("unknown"),expect(r).toEqual(null)}),it("can register filters",function(){var e={};expect(a.filters().length).toEqual(0),a.registerFilter(e),expect(a.filters().length).toEqual(1),expect(a.filters()[0]).toEqual(e);var t={},n={};a.registerAllFilters([t,n]),expect(a.filters().length).toEqual(3)}),it("won't register a filter that is in the static filters list",function(){var e={};expect(a.filters().length).toEqual(0),a.registerFilter(e),expect(a.filters().length).toEqual(1),expect(a.filters()[0]).toEqual(e);var t={propertyName:"static"};a.staticFilters=[t];var n={propertyName:"static"},r={};a.registerAllFilters([n,r]),expect(a.filters().length).toEqual(2),expect(_.find(a.filters(),function(e){return t.propertyName===e.propertyName})).toBeUndefined()}),it("adds utility methods to registered filters",function(){var e={};a.registerFilter(e),expect(e.has).toBeDefined(),expect(e.hasnt).toBeDefined(),expect(e.executeQuery).not.toBeDefined(),e.catpants=!0,expect(e.has("catpants")).toBeTruthy(),expect(e.has("catpants","doghat")).toBeFalsy(),expect(e.hasnt("catpants")).toBeFalsy(),expect(e.hasnt("catpants","doghat")).toBeTruthy()}),describe("executeQuery",function(){var e={valueUri:"some/made/up/url"},t;beforeEach(function(){t={term:"",callback:jasmine.createSpy()},a.registerFilter(e),expect(e.executeQuery).toBeDefined()}),it("should not make request for empty term",function(){e.executeQuery(t);var n=mostRecentAjaxRequest();expect(n.url).not.toEqual(e.valueUri),expect(t.callback).wasNotCalled()}),it("should make request for partial term",function(){t.term="cat",e.executeQuery(t),request=mostRecentAjaxRequest(),expect(request.url).toEqual(e.valueUri+"?q=cat");var n=["Sir Catpants","Son of Catpants"];request.response({status:200,responseText:JSON.stringify(n)}),expect(t.callback).wasCalled();var r=t.callback.mostRecentCall.args;expect(r.length).toEqual(1);var i=r[0].results;expect(i).toBeDefined(),expect(i.length).toEqual(2);var s=i[0];expect(s.id).toEqual(n[0]),expect(s.text).toEqual(n[0]),s=i[1],expect(s.id).toEqual(n[1]),expect(s.text).toEqual(n[1])})}),it("can clear out the filters",function(){var e={propertyName:"filter1"},t={propertyName:"filter2"},n={propertyName:"filter3"};a.filters([e,t,n]),expect(a.filters().length).toEqual(3),a.clearFilters(),expect(a.filters().length).toEqual(0)})})})